import { Signal } from "@mezzy/signals";
import IMetrics from "./interfaces/iMetrics";
import IMetricsGroup from "./interfaces/iMetricsGroup";
export declare abstract class MetricsBase implements IMetrics {
    protected constructor(...values: number[]);
    protected _isForceChanges: boolean;
    protected _schema: string[];
    readonly schema: string[];
    protected _setSchema(): void;
    protected readonly _array: number[];
    readonly array: number[];
    readonly isEmpty: boolean;
    readonly copy: IMetrics;
    readonly magnitude: number;
    readonly magnitudeSquared: number;
    readonly abs: this;
    internalSet: IMetricsGroup;
    readonly set: IMetricsGroup;
    isSignalChanged: boolean;
    private _isSignalChanged;
    readonly changed: Signal<this>;
    private _changed;
    protected _onChanged(): void;
    to(values: number[]): this;
    equals(values: number[]): boolean;
    toObject(): any;
    toJson(): string;
    add(values: number[]): this;
    addNumber(value: number): this;
    subtract(values: number[]): this;
    subtractNumber(value: number): this;
    multiply(values: number[]): this;
    multiplyNumber(value: number): this;
    divide(values: number[]): this;
    divideNumber(value: number): this;
    dot(values: number[]): number;
    distanceSquared(values: number[]): number;
    distance(values: number[]): number;
    min(values: number[]): this;
    max(values: number[]): this;
    clamp(min: number[], max: number[]): this;
    protected _setValues(indices: number[], values: number[]): void;
}
export default MetricsBase;
